\ crc-32.fs for DOS GForth 0.5.0
\ Petrus Prawirodidjojo 2001-10-21

code crc32  ( n1 char -- n2 )
    4 # si add			\ pop crc to edx
    si ) dx mov
    8 # cx mov			\ loop count
begin
    1 # dx shr			\ shift crc
    1 # bh rcr
    1 # bl ror			\ shift character
    .w bx ax mov		\ save character
    bh bl xor			\ xor
0< if				\ skip if equal
    $EDB88320 # dx xor		\ crc-32 polymial 1 04C1 1DB7
     then
    .w ax bx mov		\ restore character
  loop				\ next bit
    dx bx mov			\ crc to tos
    next
    end-code

\ calculate crc-32 for several strings
: crc-32  ( n1 c-addr u -- n2 )
    0 do			\ n c-addr
      dup >r c@ crc32 r> 1+ loop drop ;

\ calculate crc-32 of a string
: crc32s  ( c-addr u -- n )
    -1 rot rot crc-32 invert ;

\ test
: test
    cr cr ." crc-32" cr
    s" An Arbitrary String" 2dup type cr
    ."   crc-32: " crc32s hex u. decimal ." should be 6FBEAAE7" cr
    s" ZYXWVUTSRQPONMLKJIHGFEDBCA" 2dup type cr
    ."   crc-32: " crc32s hex u. decimal ." should be 99CDFDB2" cr ;

test

cr unused u. .( bytes free. )
key bye
\ end of application, - do not delete -