\ crc-32.f for SwiftForth
\ Petrus Prawirodidjojo 2001-10-18

code crc32  ( n1 char -- n2 )
    0 [ebp] edx mov		\ pop crc to edx
    4 # ebp add
    8 # ecx mov			\ loop count
  1 l:
    edx shr			\ shift crc
    bh rcr
    bl ror			\ shift character
    bx ax mov			\ save character
    bh bl xor			\ xor
    2 l# jns			\ skip if equal
    $EDB88320 # edx xor		\ crc-32 polymial 1 04C1 1DB7
  2 l:
    ax bx mov			\ restore character
    1 l# loop			\ next bit
    edx ebx mov			\ crc to tos
    ret
    end-code

\ calculate crc-32 for several strings
: crc-32  ( n1 c-addr u -- n2 )
    0 do			\ n c-addr
      dup >r c@ crc32 r> 1+ loop drop ;

\ calculate crc-32 of a string
: crc32s  ( c-addr u -- n )
    -1 rot rot crc-32 invert ;

\ test
: test
    cr cr ." crc-32" cr
    s" An Arbitrary String" 2dup type cr
    ."   crc-32: " crc32s hex u. decimal ." should be 6FBEAAE7" cr
    s" ZYXWVUTSRQPONMLKJIHGFEDBCA" 2dup type cr
    ."   crc-32: " crc32s hex u. decimal ." should be 99CDFDB2" cr ;

test

cr unused u. .( bytes free. )
key bye
\ end of application, - do not delete -