\ crc-32.fth for VfxForth
\ Petrus Prawirodidjojo 2001-10-20

code crc32  ( n1 char -- n2 )
	xchg	ebp, esp	\ pop crc to edx
	pop	edx
	xchg	ebp, esp
	mov	ecx, # 8	\ loop count
l$1:
	shr	edx, # 1	\ shift crc
	rcr	bh, # 1
	ror	bl, # 1		\ shift character
	mov	ax, bx		\ save character
	xor	bl, bh		\ xor
	jns	short l$2	\ skip if equal
	xor	edx, # $EDB88320	\ crc-32 polymial 1 04C1 1DB7
l$2:
	mov	bx, ax		\ restore character
	loop	l$1		\ next bit
	mov	ebx, edx	\ crc to tos
	next,
	end-code

\ calculate crc-32 for several strings
: crc-32  ( n1 c-addr u -- n2 )
    0 do			\ n c-addr
      dup >r c@ crc32 r> 1+ loop drop ;

\ calculate crc-32 of a string
: crc32s  ( c-addr u -- n )
    -1 rot rot crc-32 invert ;

\ test
: test
    cr cr ." crc-32" cr
    s" An Arbitrary String" 2dup type cr
    ."   crc-32: " crc32s hex u. decimal ." should be 6FBEAAE7" cr
    s" ZYXWVUTSRQPONMLKJIHGFEDBCA" 2dup type cr
    ."   crc-32: " crc32s hex u. decimal ." should be 99CDFDB2" cr ;

test

cr unused u. .( bytes free. )
key bye
\ end of application, - do not delete -